﻿package 
{
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	/**
	 * 変数を埋め込めるテキストを作ります。
	 * ヒアドキュメントっぽい感じです。
	 * @author Nozomi Nohara
	 */
	public class YuruHereDoc
	{
		
		//----------------------------------------------------------
		//
		//   Static Property 
		//
		//----------------------------------------------------------
	
		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------
		
		public function YuruHereDoc()
		{
			_params = new Object();
		}
		
		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------
		
		protected var _params:Object;
		
		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------
		
		/** テキストの登録 */
		public function addValue(objName:String, value:Object):void
		{
			_params[objName] =value;
		}
		
		public function convert(str:String,deleteCRLF:Boolean=false):String
		{
			var dummy:Object = "[error]";
			
			var retString:String = "";
			
			var strs:Array = str.split("#{");
			for (var i:int = 0; i < strs.length; i++)
			{
				var paramSplit:Array = strs[i].split("}");
				
				if (paramSplit.length >= 2)
				{
					var obj:Object = _params[paramSplit[0]];
					obj = obj == null ? dummy : obj;
					
					retString += obj;
					
					for (var j:int = 1; j < paramSplit.length; j++)
					{
						retString += paramSplit[j];
						
						if (j < paramSplit.length - 1)
							retString += "}";
					}
				}
				else
					retString += strs[i];
			}
			if(deleteCRLF) {
				return retString.replace( /\r/g, "" );
			} else {
				return retString;
			}
		}
	}
}